<?php

//////////
///
///   blotter.php
///
//////////

require_once('lib/authlevel.inc.php');
require_once('lib/security.inc.php');
require_once('lib/db.inc.php');



/***************\
*   FUNCTIONS   *
\***************/

function create($blotter_id)
{
   $sql  = "SELECT `log`.`log_id` AS `log_id`, ";
   $sql .=        "`log`.`type` AS `type` ";
   $sql .=        "`blotter`.`activity_id` AS `activity_id` ";
   $sql .= "FROM `log` ";
   $sql .= "JOIN `blotter_log` ";
   $sql .= "USING (`log_id`) ";
   $sql .= "JOIN `blotter` ";
   $sql .= "USING (`blotter_id`) ";
   $sql .= "WHERE `blotter_id` = '$blotter_id' AND ";
   $sql .=       "`activity_id` IN ('".implode("', '", $_SESSION['authactivityid'])."') ";
   $sql .= "ORDER BY `acquired`";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   } else if($ret['payload'] === false) {
      return false;
   }

   $tmpfile = tempnam(sys_get_temp_dir(), 'blotter');
   copy('zip/blotter.zip', $tmpfile);

   $zip = new ZipArchive;
   $zip->open($tmpfile);

   $html  = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n";
   $html .= '<html xmlns="http://www.w3.org/1999/xhtml">'."\n";
   $html .= '   <head>'."\n";
   $html .= '      <meta http-equiv="content-type" content="text/html; charset=utf-8" />'."\n";
   $html .= '      <title>Blotter</title>'."\n";
   $html .= '      <link rel="stylesheet" type="text/css" media="screen" href="styles.css" />'."\n";
   $html .= '   </head>'."\n";
   $html .= '   <body>'."\n";
   $html .= '      <div id="container">'."\n";

   foreach($ret['payload'] as $r) {
      $func = "handle_{$r->type}";
      $html .= $func($r->log_id, $zip);
   }

   $html .= '      </div>'."\n";
   $html .= '   </body>'."\n";
   $html .= '</html>'."\n";

   $zip->addFromString('index.html', $html);
   $zip->close();

   $blotter = file_get_contents($tmpfile);
   unlink($tmpfile);

   trace('blotter.create', "blotter_id=$blotter_id", 0, 0, $ret['payload'][0]->activity_id, 0, 0);

   return $blotter;
}

function handle_PRINT($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/PRINT_'.$log_id.'.bmp" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> PRINT &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>JOB NAME:</strong> '.$ret->varchar1.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                     <td width="150">'."\n";
   $html .= '                        <a href="files/PRINT_'.$log_id.'.bmp">'."\n";
   $html .= '                           <img src="files/PRINT_'.$log_id.'.bmp" width="150" border="0">'."\n";
   $html .= '                        </a>'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/PRINT_{$log_id}.bmp", $ret->longblob1->scalar);

   return $html;
}

function handle_VOIP($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`int1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/VOIP_'.$log_id.'.mp3" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> VOIP &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>PEER:</strong> '.$ret->varchar1.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/VOIP_{$log_id}.mp3", $ret->longblob1->scalar);

   return $html;
}

function handle_CLIPBOARD($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`longtext1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/CLIPBOARD_'.$log_id.'.txt" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> CLIPBOARD &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>PROCESS:</strong> '.$ret->varchar1.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '                        <strong>WINDOW:</strong> '.$ret->varchar2.'<br /><br />'."\n";
   $html .= '                        <pre>'.chunk_split($ret->longtext1->scalar, 100).'</pre><br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/CLIPBOARD_{$log_id}.txt", $ret->longtext1->scalar);

   return $html;
}

function handle_KEYLOG($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`longtext1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/KEYLOG_'.$log_id.'.txt" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> KEYLOG &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>PROCESS:</strong> '.$ret->varchar1.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '                        <strong>WINDOW:</strong> '.$ret->varchar2.'<br /><br />'."\n";
   $html .= '                        <pre>'.chunk_split($ret->longtext1->scalar, 100).'</pre><br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/KEYLOG_{$log_id}.txt", $ret->longtext1->scalar);

   return $html;
}

function handle_URL($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`longtext1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/URL_'.$log_id.'.txt" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> URL &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <pre>'.chunk_split($ret->longtext1->scalar, 100).'</pre><br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/URL_{$log_id}.txt", $ret->longtext1->scalar);

   return $html;
}

function handle_PASSWORD($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`varchar3`, ";
   $sql .=        "`varchar4` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/PASSWORD_'.$log_id.'.txt" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> PASSWORD &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>RESOURCE:</strong> '.$ret->varchar1.'<br />'."\n";
   $html .= '                        <strong>SERVICE:</strong> '.$ret->varchar2.' <br />'."\n";
   $html .= '                        <strong>USERNAME: </strong>'.$ret->varchar4.' <br />'."\n";
   $html .= '                        <strong>PASSWORD:</strong> '.$ret->varchar3.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/PASSWORD_{$log_id}.txt", "RESOURCE: {$ret->varchar1}\nSERVICE: {$ret->varchar2}\nUSERNAME: {$ret->varchar4}\nPASSWORD: {$ret->varchar3}");

   return $html;
}

function handle_SNAPSHOT($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/SNAPSHOT_'.$log_id.'.bmp" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> SNAPSHOT &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                     <td width="250">'."\n";
   $html .= '                        <a href="files/SNAPSHOT_'.$log_id.'.bmp">'."\n";
   $html .= '                           <img src="files/SNAPSHOT_'.$log_id.'.bmp" width="250" border="0">'."\n";
   $html .= '                        </a>'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/SNAPSHOT_{$log_id}.bmp", $ret->longblob1->scalar);

   return $html;
}

function handle_FILECAP($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/FILECAP_'.$log_id.'_'.$ret->varchar1.'" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> FILECAP &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>FILENAME:</strong> '.$ret->varchar1.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/FILECAP_{$log_id}_{$ret->varchar1}", $ret->longblob1->scalar);

   return $html;
}

function handle_FILEOPEN($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`longtext1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/FILEOPEN_'.$log_id.'.txt" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> FILEOPEN &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>PROCESS:</strong> '.$ret->varchar1.'<br /><br />'."\n";
   $html .= '                        <strong>FILENAME:</strong> '.$ret->varchar2.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/FILEOPEN_{$log_id}.txt", $ret->varchar2);

   return $html;
}

function handle_DOWNLOAD($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/DOWNLOAD_'.$log_id.'_'.basename($ret->varchar1).'" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> DOWNLOAD &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>FILENAME:</strong> '.$ret->varchar1.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/DOWNLOAD_{$log_id}_".basename($ret->varchar1), $ret->longblob1->scalar);

   return $html;
}

function handle_UPLOAD($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/UPLOAD_'.$log_id.'_'.basename($ret->varchar1).'" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> UPLOAD &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>FILENAME:</strong> '.$ret->varchar1.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/UPLOAD_{$log_id}_".basename($ret->varchar1), $ret->longblob1->scalar);

   return $html;
}

function handle_CHAT($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`varchar3`, ";
   $sql .=        "`longtext1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/CHAT_'.$log_id.'.txt" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> CHAT &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>PROGRAM:</strong> '.$ret->varchar1.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '                        <strong>TOPIC:</strong> '.$ret->varchar2.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '                        <strong>USERS:</strong> '.$ret->varchar3.'<br /><br />'."\n";
   $html .= '                        <pre>'.chunk_split($ret->longtext1->scalar, 100).'</pre><br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/CHAT_{$log_id}.txt", $ret->longtext1->scalar);

   return $html;
}

function handle_MIC($log_id, $zip)
{
   return;
}

function handle_WEBCAM($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return false;
   }

   $ret = $ret['payload'][0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);

   if(!is_success($note)) {
      return false;
   } else if($note['payload'] === false) {
      $note['payload'][0]->content->scalar = '';
   }

   $note = $note['payload'][0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired->scalar.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/WEBCAM_'.$log_id.'.bmp" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> WEBCAM &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content->scalar.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                     <td width="250">'."\n";
   $html .= '                        <a href="files/WEBCAM_'.$log_id.'.bmp">'."\n";
   $html .= '                           <img src="files/WEBCAM_'.$log_id.'.bmp" width="250" border="0">'."\n";
   $html .= '                        </a>'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/WEBCAM_{$log_id}.bmp", $ret->longblob1->scalar);

   return $html;
}



/**********\
*   MAIN   *
\**********/

$tagdesc[-1] = 'None';
$tagdesc[0] = 'Default';
$tagdesc[1] = 'Low';
$tagdesc[2] = 'Medium';
$tagdesc[3] = 'High';

$authuser = (isset($_SESSION['authuser']) ? $_SESSION['authuser'] : '');
$authuserid = (isset($_SESSION['authuserid']) ? $_SESSION['authuserid'] : 'none');

error_log("blotter(begin): user=$authuser($authuserid)");

header('Content-Type: text/plain');

if(!isset($_POST['blotter_id'])) {
   error_log("blotter(error): user=$authuser($authuserid), ".
                            'error="Invalid request"');
   error_log("blotter(ended): user=$authuser($authuserid)");

   header(true, true, 403);
   exit('Invalid request');
}

if(!($al & AL_VIEW)) {
   error_log("blotter(error): user=$authuser($authuserid), ".
                            'error="Invalid request"');
   error_log("blotter(ended): user=$authuser($authuserid)");

   header(true, true, 403);
   exit('Invalid request');
}

$blotter = create($_POST['blotter_id']);

if(!$blotter) {
   error_log("blotter(error): user=$authuser($authuserid), ".
                            'error="Invalid request"');
   error_log("blotter(ended): user=$authuser($authuserid)");

   header(true, true, 403);
   exit('Invalid request');
}

header('Content-Type: application/octet-stream');

echo $blotter;

error_log("blotter(ended): user=$authuser($authuserid)");

?>
