<?php

//////////
///
///   activity.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['activity.add']         = array('func'   => 'activity_add',
                                    'perm'   => AL_ADMN,
                                    'escape' => true);

$dm['activity.mod']         = array('func'   => 'activity_mod',
                                    'perm'   => AL_ADMN,
                                    'escape' => true);

$dm['activity.del']         = array('func'   => 'activity_del',
                                    'perm'   => AL_ADMN,
                                    'escape' => true);

$dm['activity.get']         = array('func'   => 'activity_get',
                                    'perm'   => AL_ADMN | AL_TECH | AL_VIEW,
                                    'escape' => true);

$dm['activity.gettarget']   = array('func'   => 'activity_gettarget',
                                    'perm'   => AL_ADMN | AL_TECH | AL_VIEW,
                                    'escape' => true);

$dm['activity.getblotter']  = array('func'   => 'activity_getblotter',
                                    'perm'   => AL_VIEW,
                                    'escape' => true);

$dm['activity.stat']        = array('func'   => 'activity_stat',
                                    'perm'   => AL_VIEW,
                                    'escape' => true);


/***************\
*   FUNCTIONS   *
\***************/

function activity_add($activity, $desc, $contact)
{
   // XXX va fatto in modo che ritornino tutti i campi appena creati

   $em[1062] = array('activity', 'exists');

   $sql  = "INSERT INTO `activity` (`activity`, ";
   $sql .=                         "`desc`, ";
   $sql .=                         "`contact`, ";
   $sql .=                         "`status`) ";
   $sql .= "VALUES ('$activity', ";
   $sql .=         "'$desc', ";
   $sql .=         "'$contact', ";
   $sql .=         "'OPEN')";

   $ret = db_query($sql, $em);

   if(!is_success($ret)) {
      return $ret;
   }

   $sql = "SELECT LAST_INSERT_ID() AS `activity_id`";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   setaccess($_SESSION['authuserid']);

   trace('activity.add', "activity=$activity({$ret['payload'][0]->activity_id})", 0, 0, $ret['payload'][0]->activity_id, 0, 0);

   return success((integer)$ret['payload'][0]->activity_id);
}

function activity_mod($activity_id, $activity, $desc, $contact, $status)
{
   $em[1062] = array('activity', 'exists');

   $sql  = "SELECT `status` ";
   $sql .= "FROM `activity` ";
   $sql .= "WHERE `activity_id` = '$activity_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return error('activity', 'nosuchactivity');
   }

   if($ret['payload'][0]->status == 'CLOSED') {
      return error('activity', 'noperm');
   }

   trace('activity.mod', "activity_id=$activity_id", 0, 0, $activity_id, 0, 0);

   $sql  = "UPDATE `activity` ";
   $sql .= "SET `activity` = '$activity', ";
   $sql .=     "`desc` = '$desc', ";
   $sql .=     "`contact` = '$contact', ";
   $sql .=     "`status` = '$status' ";
   $sql .= "WHERE `activity_id` = '$activity_id'";

   return db_query($sql, $em);
}

function activity_del($activity_id)
{
   $sql  = "DELETE FROM `activity` ";
   $sql .= "WHERE `activity_id` = '$activity_id'";

   $ret = db_query($sql);

   setaccess($_SESSION['authuserid']);

   trace('activity.del', "activity_id=$activity_id", 0, 0, $activity_id, 0, 0);

   return $ret;
}

function activity_get($activity_id)
{
   $sql  = "SELECT `activity_id`, ";
   $sql .=        "`activity`, ";
   $sql .=        "`desc`, ";
   $sql .=        "`contact`, ";
   $sql .=        "`status` ";
   $sql .= "FROM `activity` ";
   $sql .= "WHERE 1";
   $sql .= ($activity_id ? " AND `activity_id` = '$activity_id'" : '');
   $sql .= (($_SESSION['authlevel'] & AL_ADMN) ? '' : " AND `activity_id` IN ('".implode("', '", $_SESSION['authactivityid'])."')");

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

function activity_gettarget($activity_id)
{
   $sql  = "SELECT `target_id`, ";
   $sql .=        "`target`, ";
   $sql .=        "`desc` ";
   $sql .= "FROM `target` ";
   $sql .= "WHERE `activity_id` = '$activity_id'";
   $sql .= (($_SESSION['authlevel'] & AL_ADMN) ? '' : " AND `activity_id` IN ('".implode("', '", $_SESSION['authactivityid'])."')");

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

function activity_getblotter($activity_id)
{
   if(!in_array($activity_id, $_SESSION['authactivityid'])) {
      return error('activity', 'nosuchactivity');
   }

   $sql  = "SELECT `blotter_id`, ";
   $sql .=        "`blotter`, ";
   $sql .=        "`desc` ";
   $sql .= "FROM `blotter` ";
   $sql .= "WHERE `activity_id` = '$activity_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

function activity_stat($activity_id)
{
   $sql  = "SELECT `stat`.*, `backdoor`.`target_id`, `target`.`activity_id` ";
   $sql .= "FROM `stat` ";
   $sql .= "JOIN `backdoor` ";
   $sql .= "USING (`backdoor_id`) ";
   $sql .= "JOIN `target` ";
   $sql .= "USING (`target_id`) ";
   $sql .= "WHERE `activity_id` IN ('".implode("', '", $_SESSION['authactivityid'])."') ";
   $sql .= (count($activity_id) ? "AND `activity_id` IN ('".implode("', '", $activity_id)."') " : '');
   $sql .= "ORDER BY `stat`.`received` DESC";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

?>
